"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class File(ProtocolElement):
    """
    This defines a file This Record is defined by the sampleID and a URI
    Currently SampleID can be a single String or an array of strings
    if multiple samples are associated with the same file *
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "URIFile",
        "fileType",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2_1 import metrics as metrics_1_2_0

        return {
            "fileType": metrics_1_2_0.FileType,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2_1 import metrics as metrics_1_2_0

        return {
            "org.gel.models.metrics.avro.FileType": metrics_1_2_0.FileType,
            "org.gel.models.metrics.avro.File": metrics_1_2_0.File,
        }

    __slots__ = [
        "URIFile",
        "fileType",
        "SampleId",
        "md5Sum",
    ]

    def __init__(
        self,
        URIFile,
        fileType,
        SampleId=None,
        md5Sum=None,
        validate=None,
        **kwargs
    ):
        """Initialise the metrics_1_2_0.File model.

        :param URIFile:
            URI PATH
        :type URIFile: str
        :param fileType:
        :type fileType: FileType
        :param SampleId:
            Unique ID(s) of the Sample, for example in a multisample vcf this
            would have an array of all the sample ids
        :type SampleId: None | str | list[str]
        :param md5Sum:
        :type md5Sum: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.2.0"
